## karabo daemontools-3.0.7

=== CMakeLists.txt ===
# This file is part of Karabo.
#
# http://www.karabo.eu
#
# Copyright (C) European XFEL GmbH Schenefeld. All rights reserved.
#
# Karabo is free software: you can redistribute it and/or modify it under
# the terms of the MPL-2 Mozilla Public License.
#
# You should have received a copy of the MPL-2 Public License along with
# Karabo. If not, see <https://www.mozilla.org/en-US/MPL/2.0/>.
#
# Karabo is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.

cmake_minimum_required(VERSION 3.15)
project(karabo-deamontools)
add_subdirectory(src/daemontools)

=== src/daemontools/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(daemontools-encore LANGUAGES C CXX)

include(CheckSymbolExists)
include(CheckIncludeFile)

check_symbol_exists(mkfifo "sys/stat.h" HASMKFIFO)
check_symbol_exists(flock "sys/file.h" HASFLOCK)
check_symbol_exists(sigprocmask "signal.h" HASSIGPROCMASK)
check_symbol_exists(sigaction "signal.h" HASSIGACTION)
check_symbol_exists(waitpid "sys/wait.h" HASWAITPID)

file(CONFIGURE OUTPUT hasmkffo.h CONTENT "#cmakedefine HASMKFIFO\n")
file(CONFIGURE OUTPUT hasflock.h CONTENT "#cmakedefine HASFLOCK\n")
file(CONFIGURE OUTPUT hassgprm.h CONTENT "#cmakedefine HASSIGPROCMASK\n")
file(CONFIGURE OUTPUT hassgact.h CONTENT "#cmakedefine HASSIGACTION\n")
file(CONFIGURE OUTPUT hasattribute.h CONTENT "#define HASATTRIBUTE\n")
file(CONFIGURE OUTPUT haswaitp.h CONTENT "#cmakedefine HASWAITPID\n")
file(CONFIGURE OUTPUT hasshsgr.h CONTENT "/* do not define HASSHORTSETGROUPS */\n")
file(CONFIGURE OUTPUT hasmemrchr.h CONTENT "#define HASMEMRCHR 1\n")

try_run(TRYULONG64_OUT DONTCARE SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/tryulong64.c)
if(${TRYULONG64_OUT})
    configure_file(uint64.h1 uint64.h)
else()
    configure_file(uint64.h2 uint64.h)
endif()

file(CONFIGURE OUTPUT conf_supervise.c CONTENT "const char conf_supervise[] = \"supervise\";\n")

try_run(TRYDRENT_OUT DONTCARE SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/trydrent.c)
if(${TRYDRENT_OUT})
    configure_file(direntry.h1 direntry.h)
else()
    configure_file(direntry.h2 direntry.h)
endif()

try_run(TRYSYSEL_OUT DONTCARE SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/trysysel.c)
if(${TRYSYSEL_OUT})
    configure_file(select.h1 select.h)
else()
    configure_file(select.h2 select.h)
endif()

try_run(TRYPOLL_OUT DONTCARE SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/trypoll.c)
if(${TRYPOLL_OUT})
    configure_file(iopause.h1 iopause.h)
else()
    configure_file(iopause.h2 iopause.h)
endif()

file(READ warn-auto.sh SVSCANBOOT_1)
file(READ svscanboot.sh SVSCANBOOT_2)
file(CONFIGURE OUTPUT svscanboot CONTENT ${SVSCANBOOT_1}${SVSCANBOOT_2})
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/svscanboot TYPE BIN)

add_compile_options(-Wall -Wshadow -Wcast-align -Wwrite-strings -Wno-implicit)

file(GLOB_RECURSE byte_srcs CONFIGURE_DEPENDS
    byte_*.c
    fmt_*.c
    scan_*.c
    str_*.c
)

file(GLOB_RECURSE unix_srcs CONFIGURE_DEPENDS
    alloc*.c
    buffer*.c
    closeonexec.c
    env.c
    error*.c
    fd*.c
    fifo.c
    lock*.c
    ndelay*.c
    open*.c
    pathexec*.c
    prot.c
    readclose.c
    seek_set.c
    sgetopt.c
    sig*.c
    stralloc*.c
    strerr*.c
    subgetopt.c
    wait*.c
)

file(GLOB_RECURSE time_srcs CONFIGURE_DEPENDS
    tai_*.c
    taia_*.c
    iopause.c
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

add_library(unix OBJECT ${unix_srcs})
add_library(byte OBJECT ${byte_srcs})
add_library(time OBJECT ${time_srcs})

add_executable(envdir envdir.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(envini envini.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(envuidgid envuidgid.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(fghack fghack.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
install(TARGETS envdir envini envuidgid fghack)

add_executable(multilog multilog.c deepsleep.c match.c timestamp.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte> $<TARGET_OBJECTS:time>)
add_executable(pgrphack pgrphack.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(readproctitle readproctitle.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
install(TARGETS multilog pgrphack readproctitle)

add_executable(setlock setlock.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(setuidgid setuidgid.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(setuser setuser.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(softlimit softlimit.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(supervise supervise.c svpath.c deepsleep.c subreaper.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte> $<TARGET_OBJECTS:time>)
install(TARGETS setlock setuidgid setuser softlimit supervise)

add_executable(svc svc.c svpath.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(svok svok.c svpath.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(svscan svscan.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
add_executable(svstat svstat.c svpath.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte> $<TARGET_OBJECTS:time>)
add_executable(svup svup.c svpath.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
install(TARGETS svc svok svscan svstat svup)

add_executable(tai64n tai64n.c timestamp.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte> $<TARGET_OBJECTS:time>)
add_executable(tai64nlocal tai64nlocal.c $<TARGET_OBJECTS:unix> $<TARGET_OBJECTS:byte>)
install(TARGETS tai64n tai64nlocal)

=== debian/changelog ===
daemontools-encore (1:1.05-1) lucid; urgency=low

  * initial debianization

 -- Alan Grow <alangrow+daemontools-encore@gmail.com>  Mon, 11 Jul 2011 21:27:01 -0400

=== debian/control ===
Source: daemontools-encore
Section: admin
Priority: optional
Maintainer: Alan Grow <alangrow+daemontools-encore@gmail.com>
Standards-Version: 3.7.3.0

Package: daemontools-encore
Architecture: any
Depends: ${shlibs:Depends}
Replaces: daemontools-doc, daemontools
Description: a collection of tools for managing UNIX services
 supervise monitors a service. It starts the service and restarts the
 service if it dies. Setting up a new service is easy: all supervise
 needs is a directory with a run script that runs the service. 
 .
 multilog saves error messages to one or more logs. It optionally timestamps
 each line and, for each log, includes or excludes lines matching specified
 patterns. It automatically rotates logs to limit the amount of disk space
 used. If the disk fills up, it pauses and tries again, without losing any
 data.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

build: patch-stamp Makefile 

binary: build

Makefile:
	./makemake

patch: patch-stamp
patch-stamp:
	for i in `ls -1 debian/diff/*.diff || :`; do \
	  patch -p1 <$$i || exit 1; \
	done
	touch patch-stamp

%:
	dh $@
